(*= Arbitrary recursive types =*)

(* v.0.2 Olivier Laurent *)

Parameter type_mu : (Prop -> Prop) -> Prop.
Notation "µ. A" := (type_mu A) (at level 42).

Parameter type_unfold_FORBIDDEN_IN_PROOFS :
  forall A : Prop -> Prop, µ.A -> A (µ.A).
Parameter type_fold_FORBIDDEN_IN_PROOFS :
  forall A : Prop -> Prop, A (µ.A) -> µ.A.

Ltac tunfold_goal := 
  lazymatch goal with
  | |- ?g => unfold g ; apply type_fold_FORBIDDEN_IN_PROOFS ; fold g
  end.

Ltac tunfold T := unfold T ; apply type_fold_FORBIDDEN_IN_PROOFS ; fold T.

Ltac tfold T := unfold T ; apply type_unfold_FORBIDDEN_IN_PROOFS ; fold T.

Ltac hyp_tunfold H :=
  let T := type of H in
  unfold T in H ;
  let H0 := fresh in
    assert (H0 := type_unfold_FORBIDDEN_IN_PROOFS _ H) ;
    clear H ; rename H0 into H ;
  fold T in H ;
  simpl in H.
(* Ltac hyp_tunfold H := apply type_unfold_FORBIDDEN_IN_PROOFS in H. *)



