(*= Church encodings in Soft Linear Logic =*)

(* v.0.1 Olivier Laurent *)

Require Import l2coq. (* v.0.5.6 *)

Definition CSNat := forall X : Prop, !(X -> X) -> X -> X.

Fact cszero : CSNat.
Proof.
intros X f x.
lin_multiplex 0 f.
lin_assumption.
(* llcheck
SLL.
llcheck *)
Qed.

Fact csone : CSNat.
Proof.
intros X f.
lin_multiplex 1 f.
lin_assumption.
(* llcheck
SLL.
llcheck *)
Qed.

Fact cstwo : CSNat.
Proof.
intros X f x.
lin_multiplex 2 f.
lin_apply1 f0.
lin_apply1 f.
lin_assumption.
(* llcheck
SLL.
llcheck *)
Qed.

Fact scweak : CSNat -> True.
Proof.
intro n.
specialize (n True).
lin_apply2 n with.
lin_mfprom_oc.
intro ; lin_assumption.
lin_one.
(* llcheck
SLL.
llcheck *)
Qed.

