(*=== Standard library for l2coq ===*)
(*== IELL ==*)

(* v.0.5.6-1 Olivier Laurent *)

Require Export l2coq.
Require Export stdlib_mall2coq.
Require Export stdlib_lll2coq.
Require Import l2coq_auto. (* v.0.4 *)

Local Open Scope mll_scope.
Local Open Scope all_scope.


(*== Exponentials and multiplicatives ==*)

Lemma mon_oc_lmap : forall a b : Prop, !(a -> b) -> !a -> !b.
Proof.
(*
intros a b Hi Ha.
lin_mfprom_oc.
lin_apply1 Hi.
lin_assumption.
*)
lin_auto_ell.
(* llcheck
Fail LLL.
ELL.
EsLL.
SLL.
LLax.
llcheck *)
Qed.

Lemma mon_oc_tens : forall a b : Prop, (!a /\ !b) -> !(a /\ b).
Proof.
intros a b t.
lin_left_conj t.
lin_mfprom_oc.
lin_split with t0 ;
lin_assumption.
(* llcheck
Fail LLL.
ELL.
EsLL.
SLL.
LLax.
llcheck *)
Qed.

(*== Exponentials, multiplicatives and additives ==*)

Lemma iso_mae :
  forall a b : Prop, !(a [&] b) o-&-o (!a /\ !b).
Proof.
intros a b.
lin_split_equiv.
lem_apply0 imp_mae.
(*
intro t.
lin_left_conj t.
lin_mfprom_sh.
lin_with.
lin_weak_sh t1.
lin_der_sh t0.
lin_assumption.
lin_weak_sh t0.
lin_der_sh t1.
lin_assumption.
*)
lin_auto_ell.
(* llcheck
Fail LLL.
Fail ELL.
EsLL.
Fail SLL.
Fail LLax.
llcheck *)
Qed.

Local Close Scope mll_scope.
Local Close Scope all_scope.

