(*== Standard library for l2coqkc ==*)

(* v.0.1-1 Olivier Laurent *)

Require Import l2coqkc.


Lemma ax_exp_one_bot :
  CLL ({1} {P} {b}).
Proof. intro H.
clin_par H.
clin_bot H1.
clin_one.
Qed.

Lemma ax_exp_tens_par :
  forall a b : Prop, CLL (a {x} b {P} ({~}a {P} {~}b)).
Proof. intros a b H.
clin_par H.
clin_par H1.
clin_tens H0 with H2 ;
clin_ax.
Qed.

Lemma tens_comm :
  forall a b : Prop, CLL (a {x} b {P} ({~}b {P} {~}a)).
Proof. intros a b H.
clin_par H.
clin_par H1.
clin_tens H0 with H3 ;
clin_ax.
Qed.

Lemma tens_assoc : 
  forall a b c : Prop, CLL ((a {x} b) {x} c {P} ({~}a {P} ({~}b {P} {~}c))).
Proof. intros a b c H.
clin_par H.
clin_par H1.
clin_par H3.
clin_tens H0 with H2 H1.
clin_tens H0 with H2 ;
clin_ax.
clin_ax.
Qed.

Lemma tens_unit_r :
  forall a : Prop, CLL (a {x} {1} {P} {~}a).
Proof. intros a H.
clin_par H.
clin_tens H0 with H1.
clin_ax.
clin_one.
Qed.

Lemma tens_unit_l :
  forall a : Prop, CLL ({1} {x} a {P} {~}a).
Proof. intros a H.
clin_par H.
clin_tens H0 with.
clin_one.
clin_ax.
Qed.

Lemma tens_par :
  forall a b c : Prop, CLL ((a {P} (b {x} c)) {P} (({~}a {x} {~}b) {P} {~}c)).
Proof. intros a b c H.
clin_par H.
clin_par H0.
clin_par H1.
clin_tens H0 with H2.
clin_ax.
clin_tens H3 with H0 ;
clin_ax.
Qed.


